CBC_MAC_Base Class Referenceabstract

_ More...

Inheritance diagram for CBC_MAC_Base:

## Public Member Functions

void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)
| Sets the key for this object without performing parameter validation. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
void | TruncatedFinal (byte *mac, size_t size)
| Computes the hash of the current message. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length in bytes.
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length in bytes.
virtual size_t | DefaultKeyLength () const =0
| Returns default (recommended) key length in bytes.
virtual size_t | GetValidKeyLength (size_t n) const =0
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs returns whether the object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV), false otherwise.
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
virtual void | Restart ()
| Restart the hash. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

_

Definition at line 16 of file cbcmac.h.

## Member Function Documentation

## UncheckedSetKey()

void CBC_MAC_Base::UncheckedSetKey | ( | const byte * | key,
|  | unsigned int | length,
|  | const NameValuePairs & | params
| ) |  |

virtual

Sets the key for this object without performing parameter validation.

Parameters

  key | a byte buffer used to key the cipher
  length | the length of the byte buffer
  params | additional parameters passed as NameValuePairs

key must be at least DEFAULT_KEYLENGTH in length.

Implements SimpleKeyingInterface.

Definition at line 9 of file cbcmac.cpp.

## Update()

void CBC_MAC_Base::Update | ( | const byte * | input,
|  | size_t | length
| ) |  |

virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

Definition at line 16 of file cbcmac.cpp.

## TruncatedFinal()

void CBC_MAC_Base::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |

virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() call Final() and then copies digestSize bytes to digest

TruncatedFinal() restarts the hash for the next message.

Precondition
  `COUNTOF(digest) == DigestSize()` or `COUNTOF(digest) == HASH::DIGESTSIZE` ensures the output byte buffer is large enough for the digest.

Implements HashTransformation.

Definition at line 43 of file cbcmac.cpp.

## DigestSize()

unsigned int CBC_MAC_Base::DigestSize | ( |  | ) | const

inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 24 of file cbcmac.h.

The documentation for this class was generated from the following files:

- cbcmac.h
- cbcmac.cpp